<?php
/*
	twzServerShow.php

	Calls multiple instances of twzServer.php and displays the results on one page.
	Requires online.gif, offline.gif, twzServer.css, twzServerFrame.php

    dev@tweezy.net.au
    
*/
$Server=array();

$Server['any name'] = 'http://url_location_of_twzServer.php';
$Server['another'] = 'http://www.example.com/twzServer.php';


define('USE_FRAMES', true);
// If using frames, each server result can be refreshed independently,
// but the CSS for #serverN won't work (in this version anyway)
// Regardless of this setting, frames are always used for summary view

define('COLUMN_COUNT', 4); // optional
// COLUMN_COUNT is optional - if not specified there will be one column 
// for each server (ie all servers in one row across the page).
// This is fine unless you have more than 5 or 6 servers to monitor, 
// in which case you probably should use COLUMN_COUNT
// Only applies to full results page.

$ThisPage=$_SERVER['PHP_SELF'];
$debug=(isset($_GET['debug']) and 1==$_GET['debug']) ? 1 : 0;
$FullResult=(isset($_GET['r']) and 1==$_GET['r']) ? 0 : 1;
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
	<title>Server status</title>
    <link rel="stylesheet" href="twzServer.css" type="text/css" />
    <?php
    if(!$debug) { echo "<style type=\"text/css\">\r\ntd.lbl3 { display:none; }\r\n</style>\r\n"; }
    ?>
</head>
<body>

<?php

$TimeNow=date('l j F Y H:i');

if($FullResult)
    {
    echo "<table width='900' border='0' align='center' cellpadding='0'>\r\n<tr>";
    $Cols = (defined('COLUMN_COUNT') and COLUMN_COUNT>0) ? COLUMN_COUNT : count($Server);
    $ServerNum=0;
    foreach($Server as $ServerName=>$Url)
        {
        $ServerNum++;
        echo "\r\n<td align='center' valign='top' id='server$ServerNum'>";
        
        if(USE_FRAMES)
            {
            $FrameReload=GetJsFrameReload('frame'.$ServerNum);
            echo "<div class='title'><a href=\"#\" onclick=\"$FrameReload; return false;\">$ServerName</a></div>";
            $Url=urlencode($Url);
            echo "<iframe class=\"fmain\" id=\"frame$ServerNum\" scrolling=\"no\" frameborder=\"no\" src=\"twzServerFrame.php?debug=$debug&url=$Url\"><p>Your browser does not support iframes.</p></iframe>"; 
            }
        else
            {
            echo "<div class='title'>$ServerName</div>";
            $Result=@file_get_contents($Url);
            if(substr($Result,0,6)<>'<table') $Result="<br /><br />Invalid response from server <!-- $Result --><br /><br />- please try again later.";
            echo $Result; 
            }
        echo "</td>";
        if($ServerNum % $Cols == 0) 
                { echo "</tr>\r\n<tr>\r\n"; }
        }
    for($i=0; $i<($Cols - $ServerNum%$Cols); $i++)
            { echo "\t<td>&nbsp;</td>"; }

    echo "</tr>\r\n";
    echo "<tr bgcolor='#dddddd'><td colspan='$Cols' align='center'>$TimeNow</td></tr>\r\n";
    echo "<tr><td colspan='$Cols'>&nbsp;</td></tr>\r\n";
    $RefreshInfo=(USE_FRAMES) ? 'Refresh one server by clicking its name.' : '';
    echo "<tr><td colspan='$Cols' align='right'>$RefreshInfo <a href='$ThisPage'>REFRESH ALL</a> | <a href='$ThisPage?r=1'>Summary only</a></td></tr>\r\n";
    echo "</table>\r\n";
    }
else
    {
    // only show summary..
    echo '<div id="summ-outer">';
    echo '<div class="summ sn hd">Server</div>'
        .'<div class="summ sl hd">Server load</div>'
        .'<div class="summ su hd">Uptime</div>'."\r\n";
    $ServerNum=0;
    foreach($Server as $ServerName=>$Url)
        {
        $Url .= '?r=1';
        $FrameReload=GetJsFrameReload('frame'.$ServerNum);
        echo '<div class="summ sn" id="sn'.$ServerNum.'">'
                .'<a href="#" onclick="'.$FrameReload.'; return false;">'.$ServerName.'</a>'
                .'</div>'."\r\n";
        echo '<iframe class="fsub" id="frame'.$ServerNum.'" scrolling="no" frameborder="no" src="twzServerFrame.php?debug='.$debug.'&url='.$Url.'">'
            .'<p>Your browser does not support iframes.</p>'
            .'</iframe>';

        $ServerNum++;
        }
        
    echo '<div id="summ-links">';
    echo '<a href="'.$ThisPage.'?r=1">REFRESH ALL</a>';
    echo ' | <a href="'.$ThisPage.'">Full results</a>';
    echo '</div>'; // end summ-links
    echo '</div>'; // end summ-outer
    }

function GetJsFrameReload($FrameId)
    {
    //// works in FF, not IE..
    //$FrameReload="var f=getElementById('frame$ServerNum'); f.src=f.src;"; 
    //// works in FF, not IE..
    //$FrameReload="getElementById('frame$ServerNum').contentDocument.location.reload(true)";
    //// works in IE, not FF..
    //$FrameReload="document.frames['frame$ServerNum'].window.location.reload(); ";
    //// works in neither IE nor FF !..
    //$FrameReload="getElementById('frame$ServerNum').window.location.reload(); ";
    // aargh..
    return (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE')>0)
        ? "document.frames['$FrameId'].window.location.reload();"
        : "getElementById('$FrameId').contentDocument.location.reload(true);";
    }
?>

</body>
</html>